#include <stdio.h>
#include <math.h>
#include "quad.h"

typedef double Qtype;
#define Qfmt "%f"

void
quadratic_fit (Quad_Fit *fit, float *xv, float *yv, int n)
{
  int i;
  Qtype sum_x = 0, sum_y = 0, sum_xy = 0, sum_x2 = 0, sum_x2y = 0, sum_x3 = 0, sum_x4 = 0;
  Qtype ave_x, ave_y, ave_x2, s1y, s2y, s11, s12, s22;
  float temp;

  for (i=0; i<n; i++)
    {
      Qtype x = xv[i];
      Qtype y = yv[i];		/* x = X, y = X */
      //printf("x,y %g,%g\n", x, y);
      sum_x += x;
      sum_y += y;
      sum_xy += x * y;
      sum_x2 += x*x;
      sum_x2y += x*x * y;
      sum_x3 += x*x*x;
      sum_x4 += x*x*x*x;
    }

  ave_x = sum_x / n;
  ave_y = sum_y / n;
  ave_x2 = sum_x2 / n;
  //printf("ave x "Qfmt" y "Qfmt" x2 "Qfmt"\n", ave_x, ave_y, ave_x2);

  s1y = sum_xy - n * ave_x * ave_y;
  s2y = sum_x2y - n * ave_x2 * ave_y;
  s11 = sum_x2 - n * ave_x * ave_x;
  s12 = sum_x3 - n * ave_x * ave_x2;
  s22 = sum_x4 - n * ave_x2 * ave_x2;
  //printf("s1y "Qfmt" s2y "Qfmt" s11 "Qfmt" s12 "Qfmt" s22 "Qfmt"\n", s1y, s2y, s11, s12, s22);

  temp = s11 * s22 - s12 * s12;
  //printf("temp %g\n", temp);

  fit->a = (s2y * s11 - s1y * s12) / temp;
  fit->b = (s1y * s22 - s2y * s12) / temp;
  fit->c = ave_y - fit->b * ave_x - fit->a * ave_x2;
}
