
static inline void
wait_ns_1 (int n)
{
  /* This takes 1 cycle for the add, and 3 cycles for the branch.  At
     100 MHz, that's 40 nS per iteration.  */
  __asm__ __volatile__ ("\n\
1:	add	#-1, %0\n\
	bgt	1b"
	 : "=r" (n) : "0" (n));
}

/* Scale each of these to the number of iterations of the above loop,
   rounding up - delays are minimums, not maximums.  */
#define wait_ns(x) wait_ns_1 (((x) + 39) / 40)
#define wait_us(x) wait_ns_1 ((((x)*1000) + 39) / 40)
#define wait_ms(x) wait_ns_1 ((((x)*1000000) + 39) / 40)
